SystemOrganization addCategory: #'Collections-Tests-OrderPreservingDictionary'!

TestCase subclass: #OrderPreservingDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!OrderPreservingDictionaryTest commentStamp: '<historical>' prior: 0!
This class tests the OrderPreservingDictionary class using an empty dictionary, one with a single association and one with multiple associations.!

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
absentKey
	^ 'absentKey'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
absentValue
	^ 'absentValue'! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/4/2010 21:14'!
assertDictionary: aDictionary doesNotEqual: aSecondDictionary
	self
		deny: aDictionary = aSecondDictionary;
		deny: aSecondDictionary = aDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'monty 10/18/2014 08:53'!
assertDictionary: aDictionary equals: aSecondDictionary
	self
		assert: aDictionary = aDictionary;
		assert: aSecondDictionary = aSecondDictionary;
		assert: aDictionary = aSecondDictionary;
		assert: aSecondDictionary = aDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 1/19/2011 20:18'!
assertIsDictionary: anObject includesAll: anAssociationCollection
	self
		assert: (anObject isMemberOf: self dictionaryClass);
		assert: (anAssociationCollection allSatisfy: [:each | anObject includesAssociation: each])! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 1/19/2011 20:18'!
assertIsDictionary: anObject withAssociations: anAssociationCollection
	self
		assert: (anObject isMemberOf: self dictionaryClass);
		assert: anObject associations = anAssociationCollection! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/6/2010 14:17'!
assertSelector: aSelector collects: aCollection from: aDictionary
	self
		assert: (self emptyDictionary perform: aSelector) = #();
		assert: (aDictionary perform: aSelector) = aCollection asArray! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/6/2010 14:21'!
assertSelector: aSelector enumerates: aFirstCollection and: aSecondCollection from: aDictionary
	| firstEnumerated secondEnumerated|

	firstEnumerated := OrderedCollection new.
	secondEnumerated := OrderedCollection new.
	self emptyDictionary perform: aSelector with: [:first :second |
		firstEnumerated add: first.
		secondEnumerated add: second].
	self
		assert: firstEnumerated isEmpty;
		assert: secondEnumerated isEmpty.

	aDictionary perform: aSelector with: [:first :second |
		firstEnumerated add: first.
		secondEnumerated add: second].
	self
		assert: firstEnumerated asArray = aFirstCollection asArray;
		assert: secondEnumerated asArray = aSecondCollection asArray.! !

!OrderPreservingDictionaryTest methodsFor: 'assertions' stamp: 'JAAyer 12/6/2010 14:19'!
assertSelector: aSelector enumerates: aCollection from: aDictionary
	| enumerated |

	enumerated := OrderedCollection new.
	self emptyDictionary perform: aSelector with: [:each | enumerated add: each].
	self assert: enumerated isEmpty.

	aDictionary perform: aSelector with: [:each | enumerated add: each].
	self assert: enumerated asArray = aCollection asArray.! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
defaultValue
	^ 'defaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
dictionaryAssociations
	"Associations are grouped out of their natural sort order"

	^ Array
		with: 'testKey'->'testValue'
		with: 'testKey3'->'testValue3'
		with: 'testKey2'->'testValue2'
		with: 'testKey4'->'testValue4'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
dictionaryClass
	^ OrderPreservingDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 12:28'!
dictionaryKeys
	^ self dictionaryAssociations collect: [:each | each key]! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 12:28'!
dictionaryValues
	^ self dictionaryAssociations collect: [:each | each value]! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 02:17'!
dictionaryWithAssociations
	^ self dictionaryClass newFrom: self dictionaryAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 13:58'!
dictionaryWithSingleAssociation
	^ self dictionaryClass with: self singleAssociation! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 01:04'!
emptyDictionary
	^ self dictionaryClass new! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 09:06'!
internalDictionaryClass
	^ Dictionary! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 09:43'!
internalDictionaryWithAssociations
	^ self internalDictionaryClass newFrom: self dictionaryAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newDefaultValue
	^ 'newDefaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newKey
	^ 'newKey'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newValue
	^ 'newValue'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleAssociation
	^ self dictionaryAssociations first! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleKey
	^ self singleAssociation key! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/16/2011 01:09'!
singleValue
	^ self singleAssociation value! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:20'!
testAdd
	| dictionary associationToReplace replacementAssociation |

	dictionary := self emptyDictionary.
	self
		deny: (self dictionaryAssociations anySatisfy: [:each | dictionary includesAssociation: each]);
		assert: (self dictionaryAssociations allSatisfy: [:each | (dictionary add: each) == each]);
		assert: (self dictionaryAssociations allSatisfy: [:each | dictionary includesAssociation: each]);
		assert: dictionary associations = self dictionaryAssociations.

	associationToReplace := self dictionaryAssociations anyOne.
	replacementAssociation := associationToReplace copy.
	replacementAssociation value: self newValue.
	self
		assert: (dictionary add: replacementAssociation) == replacementAssociation;
		assert: (dictionary includesAssociation: replacementAssociation);
		deny: (dictionary includesAssociation: associationToReplace).
	self
		assertIsDictionary: dictionary
		withAssociations: 
			(self dictionaryAssociations
				replaceAll: associationToReplace
				with: replacementAssociation).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:20'!
testAddAll
	| dictionary |

	dictionary := self emptyDictionary.
	self deny:
		(self dictionaryAssociations anySatisfy: [:each |
			dictionary includesAssociation: each]).

	self
		assert: (dictionary addAll: self dictionaryAssociations) = self dictionaryAssociations;
		assert: dictionary associations = self dictionaryAssociations.

	"ensure adding the same associations doesn't change the order"
	self assert:
		(dictionary addAll: self dictionaryAssociations reversed) =
			self dictionaryAssociations reversed.
	self assertIsDictionary: dictionary withAssociations: self dictionaryAssociations.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:09'!
testAssociationAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey) = nil;
		assert: (dictionary associationAt: self singleKey) = self singleAssociation.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:44'!
testAssociationAtIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary associationAt: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary associationAt: self singleKey ifAbsent: [self absentValue]) = self singleAssociation.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testAssociations
	self
		assertSelector: #associations
		collects: self dictionaryAssociations
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testAssociationsDo
	self
		assertSelector: #associationsDo:
		enumerates: self dictionaryAssociations
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:21'!
testAssociationsSelelct
	| dictionary selectedAssociations rejectedAssociation |

	rejectedAssociation := self dictionaryAssociations anyOne.
	selectedAssociations := self dictionaryAssociations copyWithout: rejectedAssociation.
	dictionary :=
		self dictionaryWithAssociations
			associationsSelect: [:each | each ~= rejectedAssociation].
	self
		assertIsDictionary: dictionary withAssociations: selectedAssociations;
		deny: (dictionary includesAssociation: rejectedAssociation)! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:09'!
testAt
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	self
		assert: (dictionary at: self absentKey) = self defaultValue;
		assert: (dictionary at: self singleKey) = self singleValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:50'!
testAtIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary at: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary at: self singleKey ifAbsent: [self absentValue]) = self singleValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 13:59'!
testAtIfAbsentPut
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary at: self singleKey ifAbsentPut: [self newValue]) = self singleValue;
		assert: (dictionary at: self newKey ifAbsentPut: [self newValue]) = self newValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 09:41'!
testAtIfPresent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self assert:
		(dictionary
			at: self singleKey
			ifPresent: [:each |
				each = self singleValue
					ifTrue: [self newValue]
					ifFalse: [nil]]) = self newValue.
	self assert:
		(dictionary
			at: self absentKey
			ifPresent: [:each | self signalFailure: 'Block should not have been evaluated']) isNil.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 11:10'!
testAtPut
	| dictionary keyToUpdate oldValue |

	dictionary := self emptyDictionary.
	self assert:
		(self dictionaryAssociations allSatisfy: [:each |
			(dictionary at: each key put: each value) = each value]).
	self assert: dictionary associations = self dictionaryAssociations.

	keyToUpdate := self dictionaryKeys anyOne.
	oldValue := dictionary at: keyToUpdate.
	self
		assert: (dictionary at: keyToUpdate put: self newValue) = self newValue;
		assert: (dictionary at: keyToUpdate) = self newValue;
		assert:
			(dictionary associations =
				(self dictionaryAssociations collect: [:each |
					(each value = oldValue)
						ifTrue: [each key -> self newValue]
						ifFalse: [each]])).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 14:22'!
testCapacity
	"The current Dictionary implementation allocations more than specified; the amount allocated may
	change in the future, but it likely won't ever be less than specified, so a >= test is used instead."

	self
		assert: (self dictionaryClass new: 31) capacity >= 31;
		assert: (self dictionaryClass new: 57 withDefaultValue: nil) capacity >= 57;
		assert: (self dictionaryClass defaultValue: nil) capacity >= 10;
		assert: (self dictionaryClass new) capacity >= 10;
		assert:
			(self dictionaryClass newFrom: self dictionaryAssociations)
				capacity >= self dictionaryAssociations size.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 17:08'!
testCollect
	self
		assertIsDictionary:
			(self dictionaryWithAssociations collect: [:each | self newValue])
		withAssociations:
			(self dictionaryAssociations collect: [:each | each value: self newValue])! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/18/2011 20:18'!
testCopying
	| dictionary copy |

	dictionary := self dictionaryWithAssociations.
	copy := dictionary copy.
	self
		assert: dictionary = copy;
		deny: dictionary == copy.

	copy := dictionary copyEmpty.
	self
		deny: dictionary = copy;
		assert: copy isEmpty.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:09'!
testDefaultValue
	| dictionary |
	
	dictionary :=  self dictionaryClass new: 10 withDefaultValue: self defaultValue.
	self assert: dictionary defaultValue = self defaultValue.

	dictionary := self dictionaryClass defaultValue: self defaultValue.
	self assert: dictionary defaultValue = self defaultValue.

	dictionary defaultValue: self newDefaultValue.
	self assert: dictionary defaultValue = self newDefaultValue.

	dictionary := (self dictionaryClass newFrom: dictionary).
	self
		assert: dictionary defaultValue = self newDefaultValue;
		assert: dictionary copy defaultValue = self newDefaultValue;
		assert: dictionary copyEmpty defaultValue = self newDefaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testDo
	self
		assertSelector: #do:
		enumerates: self dictionaryValues
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 11:27'!
testEquals
	| dictionaryOne dictionaryTwo |

	dictionaryOne := self emptyDictionary.
	dictionaryTwo := self emptyDictionary.
	self assertDictionary: dictionaryOne equals: dictionaryTwo.

	"For equality, order will not matter"
	self dictionaryAssociations
		with: self dictionaryAssociations reversed
		do: [:firstAssociation :secondAssociation |
			dictionaryOne add: firstAssociation.
			dictionaryTwo add: secondAssociation.
			self
				assertDictionary: dictionaryOne doesNotEqual: self emptyDictionary;
				assertDictionary: dictionaryTwo doesNotEqual: self emptyDictionary.
			dictionaryOne size < self dictionaryAssociations size
				ifTrue: [self assertDictionary: dictionaryOne doesNotEqual: dictionaryTwo]].

	self assertDictionary: dictionaryOne equals: dictionaryTwo.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 09:45'!
testEqualsDictionary
	| orderedDictionary unorderedDictionary |

	"Comparisons with Dictionaries that contain the same associations should work too"
	orderedDictionary := self emptyDictionary.
	unorderedDictionary := self internalDictionaryClass new.
	self assertDictionary: orderedDictionary equals: unorderedDictionary.

	orderedDictionary addAll: self dictionaryAssociations.
	self assertDictionary: orderedDictionary doesNotEqual: unorderedDictionary.
	
	"Dictionary>>addAll: can only accept keyed collections as an argument, so newFrom: is
	used instead."
	unorderedDictionary := self internalDictionaryWithAssociations.
	self assertDictionary: orderedDictionary equals: unorderedDictionary.
	unorderedDictionary := self internalDictionaryClass newFrom: self dictionaryAssociations reversed.
	self assertDictionary: orderedDictionary equals: unorderedDictionary.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/18/2011 20:29'!
testHash
	self assert: self emptyDictionary hash = self emptyDictionary hash.
	self assert:
		self dictionaryWithSingleAssociation hash =
			self dictionaryWithSingleAssociation hash.
	self assert:
		self dictionaryWithAssociations hash =
			self dictionaryWithAssociations hash.
	self assert:
		self dictionaryWithAssociations hash =
			(self dictionaryClass newFrom: self dictionaryAssociations reversed) hash.

	self
		deny: self emptyDictionary hash = self dictionaryWithSingleAssociation hash;
		deny: self emptyDictionary hash = self dictionaryWithAssociations hash;
		deny: self dictionaryWithSingleAssociation hash = self dictionaryWithAssociations hash.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 14:27'!
testIncludes
	| dictionary |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryValues anySatisfy: [:each | dictionary includes: each]).

	dictionary addAll: self dictionaryAssociations.
	self assert: (self dictionaryValues allSatisfy: [:each | dictionary includes: each]).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/5/2010 02:58'!
testIncludesAssociation
	| dictionary |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryAssociations anySatisfy: [:each | dictionary includesAssociation: each]).

	dictionary addAll: self dictionaryAssociations.
	self assert: (self dictionaryAssociations allSatisfy: [:each | dictionary includesAssociation: each])! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/18/2011 21:05'!
testIncludesIdentity
	| dictionary associations values |

	dictionary := self emptyDictionary.

	"Need to save references to the exact objects for identity tests"
	associations := self dictionaryAssociations.
	values := associations collect: [:each | each value].
	self deny: (values anySatisfy: [:each | dictionary includesIdentity: each ]).

	dictionary addAll: associations.
	self
		assert: (values allSatisfy: [:each | dictionary includesIdentity: each]);
		deny: (values anySatisfy: [:each | dictionary includesIdentity: each copy]).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 14:28'!
testIncludesKey
	| dictionary |

	dictionary := self emptyDictionary.
	self deny: (self dictionaryKeys anySatisfy: [:each | dictionary includesKey: each]).

	dictionary addAll: self dictionaryAssociations.
	self assert: (self dictionaryKeys allSatisfy: [:each | dictionary includesKey: each]).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 12:11'!
testIsDictionary
	self assert: self dictionaryClass new isDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:09'!
testKeyAtIdentityValue
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyAtIdentityValue: self absentValue) = self defaultValue;
		assert: (dictionary keyAtIdentityValue: value copy) = self defaultValue;
		assert: (dictionary keyAtValue: value) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 04:19'!
testKeyAtIdentityValueIfAbsent
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyAtIdentityValue: self absentValue ifAbsent: [self absentKey]) = self absentKey;
		assert: (dictionary keyAtIdentityValue: value copy ifAbsent: [self absentKey]) = self absentKey;
		assert: (dictionary keyAtValue: value) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/19/2011 20:09'!
testKeyAtValue
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	dictionary defaultValue: self defaultValue.
	self
		assert: (dictionary keyAtValue: self absentValue) = self defaultValue;
		assert: (dictionary keyAtValue: self singleValue) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:59'!
testKeyAtValueIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary keyAtValue: self absentValue ifAbsent: [self absentKey]) = self absentKey;
		assert: (dictionary keyAtValue: self singleValue ifAbsent: [self absentKey]) = self singleKey.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 01:05'!
testKeyForIdentity
	| dictionary value |

	dictionary := self dictionaryWithSingleAssociation.
	value := dictionary at: self singleKey.
	self
		assert: (dictionary keyForIdentity: value) = self singleKey;
		assert: (dictionary keyForIdentity: value copy) isNil;
		assert: (dictionary keyForIdentity: self absentValue) isNil.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testKeys
	self
		assertSelector: #keys
		collects: self dictionaryKeys
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:21'!
testKeysAndValuesDo
	self
		assertSelector: #keysAndValuesDo:
		enumerates: self dictionaryKeys
		and: self dictionaryValues
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testKeysDo
	self
		assertSelector: #keysDo:
		enumerates: self dictionaryKeys
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testKeysSortedSafely
	"The keys are all strings, so the default #sorted implementation will suffice."
	self
		assertSelector: #keysSortedSafely
		collects: self dictionaryKeys sorted
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 09:44'!
testNewFrom
	| dictionaryOne dictionaryTwo dictionaryThree |
	
	dictionaryOne := self dictionaryClass newFrom: self dictionaryAssociations.
	dictionaryTwo := self dictionaryClass newFrom: dictionaryOne.
	dictionaryThree := self dictionaryClass newFrom: self internalDictionaryWithAssociations.

	self
		assertIsDictionary: dictionaryOne withAssociations: self dictionaryAssociations;
		assertIsDictionary: dictionaryTwo withAssociations: self dictionaryAssociations;
		assertIsDictionary: dictionaryThree includesAll: self dictionaryAssociations.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 17:34'!
testOccurancesOf
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: (dictionary occurrencesOf: self absentValue) isZero.

	dictionary add: (self dictionaryAssociations first value: self newValue).
	self assert: (dictionary occurrencesOf: self newValue) = 1.

	dictionary add: (self dictionaryAssociations second value: self newValue) .
	self assert: (dictionary occurrencesOf: self newValue) = 2.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/5/2010 03:03'!
testRemoveAll
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	self deny: dictionary isEmpty.
	dictionary removeAll.
	self assert: dictionary isEmpty.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/18/2014 09:55'!
testRemoveKey
	| dictionary |

	dictionary := self dictionaryWithAssociations.
	dictionary defaultValue: self defaultValue.
	self
		assert: (dictionary removeKey: self absentKey) = self defaultValue;
		assert: (dictionary removeKey: self dictionaryKeys first) = self dictionaryValues first;
		deny: (dictionary includesKey: self dictionaryKeys first).

	self assert: dictionary keys = self dictionaryKeys allButFirst.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 01:00'!
testRemoveKeyIfAbsent
	| dictionary |

	dictionary := self dictionaryWithSingleAssociation.
	self
		assert: (dictionary removeKey: self absentKey ifAbsent: [self absentValue]) = self absentValue;
		assert: (dictionary removeKey: self singleKey ifAbsent: [self absentValue]) = self singleValue;
		deny: (dictionary includesKey: self singleKey).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/18/2011 20:51'!
testSelect
	self
		assertIsDictionary:
			(self dictionaryWithAssociations select: [:each | each ~= self singleValue])
		withAssociations:
			(self dictionaryAssociations copyWithout: self singleAssociation)! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 16:54'!
testSize
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: dictionary size isZero.

	self dictionaryAssociations doWithIndex: [:each :i |
		dictionary add: each.
		self assert: dictionary size = i].

	self dictionaryAssociations size to: 1 by: -1 do: [:i |
		dictionary removeKey: (self dictionaryKeys at: i).
		self assert: dictionary size = (i - 1)].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:18'!
testValues
	self
		assertSelector: #values
		collects: self dictionaryValues
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 14:20'!
testValuesDo
	self
		assertSelector: #valuesDo:
		enumerates: self dictionaryValues
		from: self dictionaryWithAssociations! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 1/16/2011 00:26'!
testsKeysAndValuesRemove
	| dictionary keys |

	dictionary := self dictionaryWithAssociations.
	keys := self dictionaryKeys.
	dictionary keysAndValuesRemove: [:key :value | keys first = key or: [keys third = key]].

	self
		deny: (dictionary includesKey: keys first);
		deny: (dictionary includesKey: keys third);
		assert:
			(((keys copyWithout: keys first) copyWithout: keys third)
				allSatisfy: [:each | dictionary includesKey: each]).! !

OrderPreservingDictionaryTest subclass: #OrderPreservingIdentityDictionaryTest
	instanceVariableNames: 'identityAssociations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!OrderPreservingIdentityDictionaryTest class methodsFor: 'testing' stamp: 'monty 10/18/2014 09:38'!
shouldInheritSelectors
	^ true! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 09:37'!
dictionaryAssociations
	identityAssociations
		ifNil: [| key |
			key := 'testKey'.
			identityAssociations :=
				(#('testValue' 'testValue3' 'testValue2' 'testValue4') collect: [:each |
					(key := key copy) -> each])].

	^ identityAssociations collect: [:each | each copy].! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 08:55'!
dictionaryClass
	^ OrderPreservingIdentityDictionary! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 09:07'!
internalDictionaryClass
	^ IdentityDictionary! !
